﻿using LineMetrics.API;
using LineMetrics.API.DataTypes;
using LineMetrics.API.Exceptions;
using LineMetrics.API.Extensions;
using LineMetrics.API.RequestTypes;
using LineMetrics.API.ReturnTypes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;

namespace TestConsole
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                //IServices service = new APIServices("api_1502b3a0691", "39ed518cfeb84c331e7812a73f5e19ae");
                ILMService api = new LineMetricsService("api_176ace7a035", "f9123f666865530c136e9f33e714893d");
                //ILMService api = new LineMetricsService("api_176ace7a035", "f9123f666865530c136e9f33e714893d", "email", "password");
                //ILMService api = new LineMetricsService("api_18866a721f6", "624a153510e026f5c3e5fc77c92e5d4d");
                //var obj = api.LoadObject("be6878b50f9b40c6971c6d86c71c36e7");
                //var x = ((Property)obj).Value;
                //Console.WriteLine(x);
                ////Console.WriteLine(obj);
                //((Property)obj).Value = new LineMetrics.API.DataTypes.Timestamp { Value = DateTime.Now };
                //obj = api.LoadObject("be6878b50f9b40c6971c6d86c71c36e7");
                //Console.WriteLine(obj);
                //Console.ReadKey();
                //return;
                //service.Authenticate();
                //service.
                /*var assets = service.LoadAssets();
                string delId = null;
                foreach (var asset in assets)
                {
                    Console.WriteLine(asset);
                    //Console.WriteLine(service.UpdateObject(asset, null, null, "Peters Gebaeude"));
                    //Console.WriteLine(service.LoadObject(asset.Id));
                    //Console.WriteLine(service.LoadObjectByCustomKey(asset.CustomKey));
                    foreach (var property in asset.LoadProperties())
                    {
                        Console.WriteLine(property);
                    }
                    foreach (var measurementPoint in asset.LoadDataStreams())
                    {
                        Console.WriteLine(measurementPoint);
                        //Console.WriteLine(measurementPoint.LoadLastValue());
                    }

                    Console.WriteLine("------");
                }

                DataStreamConfigRequest configReq = new DataStreamConfigRequest
                {
                    CustomKey = "building_3",
                    Alias = "tank"
                };
                var dataType = service.LoadDataStreamConfig(configReq);
                Console.WriteLine(dataType);

                LastValueDataReadRequest lastValueRequest = new LastValueDataReadRequest
                {
                    CustomKey = "building_3",
                    Alias = "tank",
                    DataType = dataType.Output
                };

                Console.WriteLine(service.ReadLastValue(lastValueRequest));

                DataReadRequest dataReadRequest = new DataReadRequest
                {
                    CustomKey = "building_3",
                    Alias = "tank",
                    DataType = dataType.Output,
                    From = DateTime.Now.AddDays(-1),
                    To = DateTime.Now,
                    Function = Function.AVERAGE
                };
                var readResponse = service.ReadData(dataReadRequest);

                foreach (var data in readResponse)
                {
                    Console.WriteLine(data);
                }

                DataWriteRequest writeReq = new DataWriteRequest
                {
                    CustomKey = "building_3",
                    Alias = "tank"
                };

                writeReq.PayLoad.Add(new DoubleAverage
                {
                    Maximum = 5.3,
                    Minimum = 1.2,
                    Value = 3.4
                });
                KeyValueDataWriteRequest keyValueWriteReq = new KeyValueDataWriteRequest
                {
                    CustomKey = "building_3",
                    Alias = "tank"
                };
                keyValueWriteReq.PayLoad.Add("tankval", new DoubleAverage
                {
                    Maximum = 5.3,
                    Minimum = 1.2,
                    Value = 3.4
                });

                var writeResponse = service.WriteData(writeReq);

                foreach (var response in writeResponse)
                {
                    Console.WriteLine(response);
                }

                var keyValueWriteResponse = service.WriteData(keyValueWriteReq);

                foreach (var response in keyValueWriteResponse)
                {
                    Console.WriteLine(response);
                }

                var templates = service.LoadTemplates();

                foreach (var template in templates)
                {
                    Console.WriteLine(template);
                    var requiredFields = service.LoadTemplateRequiredFields(template);
                    foreach (var requiredField in requiredFields)
                    {
                        Console.WriteLine(requiredField);
                    }
                    delId = service.CreateAsset(template, requiredFields);
                    Console.WriteLine(delId);
                }

                var delObj = service.LoadObject(delId);
                Console.WriteLine(service.DeleteObject(delObj, true));
                */
                var assets = api.LoadAssets();

                foreach (var asset in assets)
                {
                    //Console.WriteLine(asset);
                    Console.WriteLine(asset.Title);
                    asset.Title = "Peter_Title_Testä3";
                    asset.Save();
                }
                assets = api.LoadAssets();

                foreach (var asset in assets)
                {
                    Console.WriteLine(asset.Title);
                }
                Console.ReadKey();
                return;

                /*int i = 1;
                var rootAssets = api.LoadAssets();
                
                foreach (var asset in rootAssets)
                {
                    //asset.CustomKey = "5";
                    //asset.ChildrenInfo
                    if (asset.CustomKey.IsNullOrWhiteSpace())
                    {
                        Console.WriteLine(api.DeleteObject(asset, true));
                        //asset.Title = "Peters Gebaeude " + i++;
                        //asset.Save();
                        /*var dataStreams = asset.LoadDataStreams();
                        foreach (var dataStream in dataStreams)
                        {
                            //Console.WriteLine(dataStream.LoadLastValue());
                            DoubleAverage avg = new DoubleAverage
                            {
                                Maximum = 5.3,
                                Minimum = 1.2,
                                Value = 3.4
                            };
                            Console.WriteLine(dataStream.WriteData(avg));
                        }
                    }
                }*/

                /*Asset building1 = (Asset)service.LoadObject("building_1");
                Asset building2 = (Asset)service.LoadObject("building_2");

                building2.ParentId = building1.ObjectId;
                building2.Save();*/

                /*var building1 = (Asset)service.LoadObject("building_1");
                //building1.Title = "Peters Gebaeude " + i;
                //building1.Save();
                var dataStreams = building1.LoadDataStreams();
                foreach (var dataStream in dataStreams)
                {
                    Console.WriteLine(dataStream.LoadLastValue());
                    DoubleAverage avg = new DoubleAverage
                    {
                        Maximum = 5.3,
                        Minimum = 1.2,
                        Value = 3.4
                    };
                    Console.WriteLine(dataStream.WriteData(avg));
                }*/

                var templates = api.LoadTemplates();
                foreach (var template in templates)
                {
                    Dictionary<string, Base> data = new Dictionary<string, Base>();

                    foreach (var requiredField in template.RequiredFields)
                    {
                        Base field = null;
                        switch (requiredField.DataType.Name)
                        {
                            case "String":
                                field = new LineMetrics.API.DataTypes.String { Value = "Peter" };
                                break;
                            default:
                                field = new LineMetrics.API.DataTypes.Double { Value = 3.14 };
                                break;
                        }

                        string key = requiredField.Alias;
                        if (key.IsNullOrWhiteSpace())
                        {
                            key = requiredField.Id;
                        }
                        data.Add(key, field);
                    }
                    var uid = template.CreateAsset(data);
                    Console.WriteLine(uid);

                    var building1 = (Asset)api.LoadObject(uid);
                    Console.WriteLine(building1);
                    var dataStreams = building1.LoadDataStreams();
                    foreach (var dataStream in dataStreams)
                    {
                        DoubleAverage avg = new DoubleAverage
                        {
                            Maximum = 5.3,
                            Minimum = 1.2,
                            Value = 3.4
                        };
                        Console.WriteLine(dataStream.SaveData(avg));
                        Thread.Sleep(10000);
                        Console.WriteLine(dataStream.LoadLastValue());
                        foreach (var dataResponse in dataStream.LoadData(DateTime.Now.AddHours(-3), DateTime.Now, null, null, Function.AVERAGE))
                        {
                            Console.WriteLine(dataResponse);
                        }
                    }
                    foreach (var prop in building1.LoadProperties())
                    {
                        if (prop.DataTypes.Input == typeof(LineMetrics.API.DataTypes.Double))
                        {
                            var avg = new LineMetrics.API.DataTypes.Double
                            {
                                Value = 3.4
                            };
                            prop.Value = avg;
                        }
                    }
                    //building1.Title = "Peters Template Gebaeude";
                    //building1.Save();
                   
                }

                //var building1 = (Property)service.LoadObject("building_1/size");
                /*foreach (var prop in building1.LoadProperties())
                {
                    Console.WriteLine(prop);
                }*/

                //building1.Data = new LineMetrics.API.DataTypes.Double
                //{
                //    Value = 2.15
                //};


                Console.ReadKey();
                return;

                /*Console.WriteLine(service.AuthenticationToken.AccessToken);
                var inputs = service.GetInputs();
                foreach (var input in inputs)
                {
                    Console.WriteLine(input);
                }
                DoubleAverage da = new DoubleAverage
                {
                    Maximum = 5.3,
                    Minimum = 1.2,
                    Value = 3.4
                };
                DataWriteRequest write = new DataWriteRequest
                {
                    Input = inputs.SingleOrDefault(i => i.DataType == typeof(DoubleAverage)),
                    PayLoad = da
                };
                var response = service.WriteData(write);

                Console.WriteLine(response);

                Bool boolVal = new Bool
                {
                    Value = true
                };
                DataWriteRequest write2 = new DataWriteRequest
                {
                    Input = inputs.SingleOrDefault(i => i.DataType == typeof(Bool)),
                    PayLoad = boolVal
                };
                var response2 = service.WriteData(write2);

                Console.WriteLine(response2);

                DataReadRequest dataRead = new DataReadRequest(Function.AVG, inputs.SingleOrDefault(i => i.DataType == typeof(DoubleAverage)), DateTime.Now.AddHours(-3), DateTime.Now.AddMinutes(1), null, null);
                service.ReadData(dataRead).ForEach(r => Console.WriteLine(r));

                DataReadRequest dataRead2 = new DataReadRequest(Function.RAW, inputs.SingleOrDefault(i => i.DataType == typeof(DoubleAverage)), DateTime.Now.AddHours(-3), DateTime.Now.AddMinutes(1), null, null);
                service.ReadData(dataRead2).ForEach(r => Console.WriteLine(r));

                DataReadRequest dataRead3 = new DataReadRequest(Function.RAW, inputs.SingleOrDefault(i => i.DataType == typeof(Bool)), DateTime.Now.AddHours(-3), DateTime.Now.AddMinutes(1), null, null);
                service.ReadData(dataRead3).ForEach(r => Console.WriteLine(r));*/
            }
            catch (RequestException e)
            {
                Console.WriteLine("Exception: {0}, msg: {1}, errordetails: {2}", e.GetType(), e.Message, e.Error);
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            Console.ReadKey();

        }
    }
}
